/****************************************************************************
** Form implementation generated from reading ui file 'yohood.ui'
**
** Created: Fri Apr 26 18:10:46 2002
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "YohoodGUI.h"
#include "moc_YohoodGUI.cpp"

#include <qgroupbox.h>
#include <qheader.h>
#include <qiconview.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qtextview.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qtextstream.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <stdlib.h>

/* 
 *  Constructs a YohoodGUI which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
YohoodGUI::YohoodGUI( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    QPixmap image0("mynet.bmp"); 
    if ( !name )
	setName( "YohoodGUI" );
    resize( 789, 605 ); 
    setCaption( tr( "YOHOOD..." ) );

    GroupBox = new QGroupBox( this, "GroupBox2_2" );
    GroupBox->setGeometry( QRect( 10, 10, 770, 580 ) ); 
    GroupBox->setTitle( tr( "YOHOOD" ) );

    PushButtonWWW= new QPushButton( GroupBox, "PushButtonWWW" );
    PushButtonWWW->setGeometry( QRect( 650, 500, 109, 26 ) ); 
    PushButtonWWW->setText( tr( "WWW" ) );

    PushButtonRefresh = new QPushButton( GroupBox, "PushButtonRefresh" );
    PushButtonRefresh->setGeometry( QRect( 650, 460, 109, 26 ) ); 
    PushButtonRefresh->setText( tr( "Refresh" ) );

    PushButtonSSH = new QPushButton( GroupBox, "PushButtonSSH" );
    PushButtonSSH->setGeometry( QRect( 650, 540, 109, 26 ) ); 
    PushButtonSSH->setText( tr( "SSH" ) );

    TextView = new QTextView( GroupBox, "TextView1_2" );
    TextView->setGeometry( QRect( 240, 460, 400, 110 ) ); 
    TextView->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, TextView->sizePolicy().hasHeightForWidth() ) );
    TextView->setResizePolicy( QTextView::AutoOneFit );

    IconView = new QIconView( GroupBox, "IconView1_2" );
    IconView->setGeometry( QRect( 240, 20, 520, 430 ) ); 
    IconView->setResizePolicy( QIconView::AutoOneFit );

    ListView = new QListView( GroupBox, "ListView1" );
    ListView->addColumn( tr( "Network Neighborhood   " ) );
    ListView->header()->setLabel( ListView->header()->count() - 1, image0, tr( "Network Neighborhood   " ) );
    ListView->header()->setClickEnabled( FALSE, ListView->header()->count() - 1 );
    ListView->setGeometry( QRect( 10, 20, 220, 550 ) ); 
    ListView->setResizePolicy( QScrollView::Manual );

    // signals and slots connections
    connect( PushButtonSSH, SIGNAL( clicked() ), this, SLOT( connectWithSHH() ) );
    connect( PushButtonRefresh, SIGNAL( clicked() ), this, SLOT( refreshHood() ) );
    connect( PushButtonWWW, SIGNAL( clicked() ), this, SLOT( connectWithWWW() ) );
    connect( ListView, SIGNAL( doubleClicked(QListViewItem*) ), this, SLOT( displayGroupHosts(QListViewItem*) ) );
    connect( IconView, SIGNAL( doubleClicked(QIconViewItem*) ), this, SLOT( displayHostInfo(QIconViewItem*) ) );
    myCompIcon = new QPixmap("mycomp.bmp");
    workgroupIcon = new QPixmap("workgroup.bmp");
    refreshHood();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
YohoodGUI::~YohoodGUI()
{
    // no need to delete child widgets, Qt does it all for us
}

char* YohoodGUI::resolveNameSubjectToView(struct host *h){
  
   if(strcmp((char *)h->name, "") == 0){
	   return (char*) h->ip;
   }
   else return (char*) h->name;
	
}

struct host* YohoodGUI::resolveNameViewToSubject(QString *s){

	struct hostent *he;

   if(s->at(0).isDigit())
        return (struct host*) hash_hash((HASH) yohood, (char*)s->ascii());
   else{
       struct in_addr addr;
	he = gethostbyname((char *) s->ascii());
	memcpy(&addr, he->h_addr_list[0], sizeof(addr));
	
       cout << inet_ntoa(addr) << endl;
       return (struct host*) hash_hash((HASH) yohood, inet_ntoa(addr));
   }
	
}
int YohoodGUI::listViewContainsItem(char* group){

	QListViewItemIterator it(ListView);
	for(; it.current(); ++it)
		if(it.current()->text(0).compare(QString(group)) == 0)
		   return 1;
        return 0;
}
void YohoodGUI::addGroup(struct host h){
   if(!listViewContainsItem((char*)h.group)){
    QListViewItem *item =  new QListViewItem( ListView, (char*)h.group);
    item->setPixmap(0, *workgroupIcon);
   }
}

int YohoodGUI::iconViewContainsItem(char* host){
	QIconViewItem *item;
	for(item = IconView->firstItem(); item; item = item->nextItem())
	     if(item->text().compare(QString(host)) == 0)
		return 1;
	return 0;
}

void YohoodGUI::addHost(struct host h){

   char *hostNameInGUI = resolveNameSubjectToView(&h);
   
   if(!iconViewContainsItem(hostNameInGUI)){
      if(h.alive){	   
         new QIconViewItem( IconView, hostNameInGUI, *myCompIcon);
      }
   }
}

void YohoodGUI::connectWithSHH()
{
	QIconViewItem *currentHost = IconView->currentItem();
	if(currentHost){
	   QString s;
           QTextOStream(&s) << "konsole -e ssh " << currentHost->text() << " &";	   
	   system(s.latin1());
	}
}

void YohoodGUI::connectWithWWW()
{
	QIconViewItem *currentHost = IconView->currentItem();
	if(currentHost){
	  QString s;
	  QTextOStream(&s) << "konqueror http://" << currentHost->text() << " &";
	  system(s.latin1());
	}
}

void YohoodGUI::refreshHood()
{
    // refresh groups	
    struct host *h;
    h= (struct host*) yohood->data;
    for(int i=0; i < MAXHOSTS; i++){
	    if(h[i].tstamp != 0){
		addGroup(h[i]);
		QListViewItem *currentGroup = ListView->selectedItem();
		// refresh hosts if any group is selected
		if(currentGroup && currentGroup->text(0).compare(tr((char*) h[i].group)) == 0)
		   addHost(h[i]);
	    }
    }
}
void YohoodGUI::displayGroupHosts(QListViewItem* group)
{
    // clear Iconview
    IconView->clear();
    struct host *h;
    h= (struct host*) yohood->data;
    for(int i=0; i < MAXHOSTS; i++){
	    if(h[i].tstamp != 0){
		    if(group->text(0).compare(tr((char*) h[i].group)) == 0)
			    addHost(h[i]);
	    }
    }


}
void YohoodGUI::displayHostInfo(QIconViewItem* host){

    struct host *h;
    /*h= (struct host*) yohood->data;
    for(int i=0; i < MAXHOSTS; i++){
	    if(h[i].tstamp != 0){
		    if(host->text().compare(tr((char*) h[i].name)) == 0){*/
                        QString hostName(host->text().latin1());
	                h = resolveNameViewToSubject(&hostName);
			QString s = tr("WORK GROUP : ") + tr((char*)h->group) +
				    tr("\nHOST NAME  : ") + tr((char*)h->name) +
				    tr("\nIP ADDRESS : " + tr((char*)h->ip)) +
				    tr("\nMAC ADDRESS: " + tr((char*)h->mac));
  			TextView->setText(s);
			return;
		    //}
	   // }
   // }
}

